<?php

function papernap_register_settings(){
    register_setting('papernap_setting_group', 'papernap_setting');
}

add_action('admin_init', 'papernap_register_settings');

function papernap_load_scripts(){
    wp_enqueue_style('papernap_bootstrap_style', plugin_dir_url(__FILE__) . 'css/bootstrap.min.css', array(), time(), false);
    wp_enqueue_style('papernap_fontawesome', plugin_dir_url(__FILE__) . 'css/font-awesome.min.css', array(), time(), false);
    wp_enqueue_style('papernap_slickslider', plugin_dir_url(__FILE__) . 'css/slick.css', array(), time(), false);
    wp_enqueue_style('papernap_chosen', plugin_dir_url(__FILE__) . 'css/chosen.css', array(), time(), false);
    wp_enqueue_style('papernap_jqueryUI', plugin_dir_url(__FILE__) . 'css/jquery-ui.min.css', array(), time(), false);
    wp_enqueue_style('papernap_style', plugin_dir_url(__FILE__) . 'css/papernap-style.css', array(), time(), false);
    wp_enqueue_style('papernap_plugin_style', plugin_dir_url(__FILE__) . 'css/papernap.css', array(), time(), false);
    wp_enqueue_script('papernap_bootstrap_script', plugin_dir_url(__FILE__) . 'js/bootstrap.min.js', array('jquery'), time(), true);
    wp_enqueue_script('papernap_shopify_air', plugin_dir_url(__FILE__).'js/papernap-main.js', array('jquery'), time(), true);
    wp_enqueue_script('papernap_chosen', plugin_dir_url(__FILE__).'js/chosen.jquery.min.js', array('jquery'), time(), true);
    wp_enqueue_script('papernap_prism', plugin_dir_url(__FILE__).'js/prism.js', array('jquery'), time(), true);
    wp_enqueue_script('papernap_init', plugin_dir_url(__FILE__).'js/init.js', array('jquery'), time(), true);
    wp_enqueue_script('papernap_popper', plugin_dir_url(__FILE__).'js/popper.min.js', array('jquery'), time(), true);
    wp_enqueue_script('papernap_slick', plugin_dir_url(__FILE__).'js/slick.js', array('jquery'), time(), true);
}

add_action('wp_enqueue_scripts', 'papernap_load_scripts', 99);

function PapernapUpSellOnProductPage()
{
    global $product;
    $categories = papernap_get_product_categories_in_hierarchy($product->get_id());
    $productName = $product->get_name();
    $productDescription = $product->get_description();
    $content = $productName . ' ' . $productDescription;
    $PapernapNonce = wp_create_nonce('papernap_details');
    echo '<div id="airrev-suggest-sp-app" data-id="'.$product->get_id().'">
</div>
    <input type="hidden" id="papernap-nonce" name="papernap-nonce" value="' . $PapernapNonce . '" />
<input type="hidden" id="papernap-content" name="papernap-content" value="' . strip_tags($content) . '" />
<input type="hidden" id="papernap-category" name="papernap-category" value="' . $categories . '" />
<script>
            window.onload = function () //executes when the page finishes loading
            {
                setTimeout(papernapShowContent, 500);
            };
        </script>';
}

function papernap_get_product_categories_in_hierarchy($productID)
{
    $terms = get_the_terms($productID, 'product_cat');
    $cat1 = '';
    $cat2 = '';
    $cat3 = '';
    foreach ($terms as $data) {
        $ancestors = get_ancestors($data->term_id, 'product_cat');
        if (count($ancestors) == 2) {
            $cat3 = $data->name;
        } elseif (count($ancestors) == 1) {
            $cat2 = $data->name;
        } else {
            $cat1 = $data->name;
        }
    }
    return $cat1 . (!empty($cat2) ? (!empty($cat3) ? '|||' . $cat2 . '|||' . $cat3 : '|||' . $cat2) : '');
}

function papernap_order_details($order_id)
{
    if (!$order_id)
        return;

    $productsSTR = '';
    $orderDetails['id'] = $order_id;
    $order = wc_get_order($order_id);

    $orderDetails['created_at'] = $order->get_date_created();
    $orderDetails['updated_at'] = $order->get_date_modified();
    $orderDetails['total_price'] = $order->get_total();
    $orderDetails['currency'] = $order->get_currency();
    $orderDetails['cancelled_at'] = ($order->get_status() == 'Cancelled' ? $order->get_date_modified() : '');
    $orderDetails['financial_status'] = $order->get_status();
    $orderDetails['browser_ip'] = $order->get_customer_ip_address();
    $orderDetails['email'] = $order->get_billing_email();
    $orderDetails['paidDate'] = $order->get_date_paid();

    $i = 0;
    foreach ($order->get_items() as $item_id => $item) {
        // Get the product object
        $product = $item->get_product();

        if($i == 0){
            $productsSTR = $item->get_product_id().'|||'.$product->get_sku().'|||'.$item->get_name().'|||'.$product->get_price().'|||'.$item->get_quantity();
        }else{
            $productsSTR = $productsSTR.'$$$$'.$item->get_product_id().'|||'.$product->get_sku().'|||'.$item->get_name().'|||'.$product->get_price().'|||'.$item->get_quantity();
        }

        $i++;
    }

    echo '<input type="hidden" id="papernap-order-id" name="papernap-order-id" value="' . $orderDetails['id'] . '" />
    <input type="hidden" id="papernap-prod-det" name="papernap-prod-det" value="' . $productsSTR . '" />
    <input type="hidden" id="papernap-order-created" name="papernap-order-created" value="' . $orderDetails['created_at'] . '" />
    <input type="hidden" id="papernap-order-updated" name="papernap-order-updated" value="' . $orderDetails['updated_at'] . '" />
    <input type="hidden" id="papernap-order-price" name="papernap-order-price" value="' . $orderDetails['total_price'] . '" />
    <input type="hidden" id="papernap-order-currency" name="papernap-order-currency" value="' . $orderDetails['currency'] . '" />
    <input type="hidden" id="papernap-order-cancel" name="papernap-order-cancel" value="' . $orderDetails['cancelled_at'] . '" />
    <input type="hidden" id="papernap-order-status" name="papernap-order-status" value="' . $orderDetails['financial_status'] . '" />
    <input type="hidden" id="papernap-order-ip" name="papernap-order-ip" value="' . $orderDetails['browser_ip'] . '" />
    <input type="hidden" id="papernap-order-email" name="papernap-order-email" value="' . $orderDetails['email'] . '" />
    <input type="hidden" id="papernap-order-paidDate" name="papernap-order-paidDate" value="' . $orderDetails['paidDate'] . '" />
        <input type="hidden" id="papernap-order-nonce" value="'.wp_create_nonce('save_papernap_order_details').'" />
        <script>
            window.onload = function () //executes when the page finishes loading
            {
                setTimeout(Papertrackorderdetails, 2000);
            };
        </script>';
}

add_action('woocommerce_after_single_product', 'PapernapUpSellOnProductPage');
add_action('woocommerce_thankyou', 'papernap_order_details', 10, 1);

?>
